$! build_vms.com, the OpenVMS CDRTOOLS build procedure
$!
$! Version 11-Sep-2003
$! Constructed for CDRTOOLS 1.11A21
$! Tested on OpenVMS Alpha V7.3-1, using C V6.5-001
$! This version removes ancient and unnecessary OpenVMS code-paths.
$! based on build_all.com.
$!
$! Author of BUILD_ALL:
$!   Unknown; Possibly Dr. Eberhard Heuser-Hofmann?
$!
$! Updates:
$!   Stephen Hoffman, 11-Sep-2003; numerous updates to this DCL, and
$!   to the OpenVMS-related code-paths within the CDRTOOLS source code.
$!
$!
$! If you are building on an older OpenVMS version or with an older
$! C compiler and find yourself missing some functions, please first
$! familiarize yourself with the backport library that is available
$! with C V5.6 and later.  (This library isn't used for backporting 
$! application code to earlier OpenVMS versions, this library is a
$! backport of newer C functions for use on older OpenVMS versions.)
$!
$!
$! Process errors, allow recovery of default settings.
$!
$ on warning then goto main_exit
$ on control_y then goto main_exit
$!
$! Force the current default directory to match assumptions.
$!
$ ccopt = ""   ! $ ccopt = "/debug/noopt"
$ linkopt = "" ! $ linkopt = "/debug"
$ curdef = f$environment("DEFAULT")
$ myname = f$environment("PROCEDURE")
$ myname = f$parse(myname,,,,"NO_CONCEAL")
$ mydir  = f$parse(myname,,,"DIRECTORY") - "][" - "><" - "]" - "[" - ">" - "<"
$ mydef = f$parse(myname,,,"DEVICE") + "[" + mydir + "]"
$ myroot = f$parse(myname,,,"DEVICE") + "[" + mydir + ".]"
$ set default 'mydef'
$ define/trans=(conceal,terminal)/nolog cdrroot 'myroot'
$!
$!
$! Clean up any existing mess, and start CDRECORD build.
$!
$ if f$trnlnm("decc$system_include","PROCESS") .nes. "" then deassign/process decc$system_include
$ if f$trnlnm("decc$user_include","PROCESS") .nes. "" then deassign/process decc$user_include
$!
$! uniform use of our own process-level logicals eliminates the need
$! for the following checks....
$!
$!$ if f$trnlnm("decc$system_include") .nes. ""
$!$ then
$!$   ! since this logical can mess up the build
$!$   write sys$output "Please deassign the decc$system_include logical name."
$!$   write sys$output "BUILD_VMS.COM cannot continue."
$!$   exit
$!$ endif
$!$ if f$trnlnm("decc$user_include") .nes. ""
$!$ then
$!$   write sys$output "Please deassign the decc$user_include logical name."
$!$   write sys$output "BUILD_VMS.COM cannot continue."
$!$   exit
$!$ endif
$ if f$search("cdrroot:[000000]vmstmp.DIR") .eqs. ""
$ then 
$   create/dir cdrroot:[vmstmp]
$ else
$   if f$search("cdrroot:[vmstmp]*.*") .nes. "" then set security/protect=(s:rwed,o:rwed) cdrroot:[vmstmp...]*.*;*
$   if f$search("cdrroot:[vmstmp]inc.DIR") .nes. "" then if f$search("cdrroot:[vmstmp.inc]*.*") .nes. "" then delete cdrroot:[vmstmp.inc]*.*;*
$   if f$search("cdrroot:[vmstmp]lib.DIR") .nes. "" then if f$search("cdrroot:[vmstmp.lib]*.*") .nes. "" then delete cdrroot:[vmstmp.lib]*.*;*
$   if f$search("cdrroot:[vmstmp]stdio.DIR") .nes. "" then if f$search("cdrroot:[vmstmp.stdio]*.*") .nes. "" then delete cdrroot:[vmstmp.stdio]*.*;*
$   if f$search("cdrroot:[vmstmp]libunls.DIR") .nes. "" then if f$search("cdrroot:[vmstmp.libunls]*.*") .nes. "" then delete cdrroot:[vmstmp.libunls]*.*;*
$   if f$search("cdrroot:[vmstmp]*.*") .nes. "" then delete cdrroot:[vmstmp]*.*;*
$ endif
$
$
$!
$! Copy [cdrecord]*.c last, as we want those files to overwrite any lurking links.
$ copy cdrroot:[libscg]*.c      cdrroot:[vmstmp]
$!$ copy cdrroot:[libscg]*.h      cdrroot:[vmstmp]
$ copy cdrroot:[libdeflt]*.c    cdrroot:[vmstmp]
$ copy cdrroot:[mkisofs]*.c     cdrroot:[vmstmp]
$ copy cdrroot:[cdrecord]*.c    cdrroot:[vmstmp]
$!$ copy cdrroot:[cdrecord]*.h    cdrroot:[vmstmp]
$!$ copy cdrroot:[mkisofs]*.h     cdrroot:[vmstmp]
$
$ define/nolog scg cdrroot:[libscg.scg]
$
$ set default cdrroot:[vmstmp]
$
$ define/nolog decc$system_include cdrroot:[mkisofs],cdrroot:[cdrecord],cdrroot:[include],cdrroot:[libscg]
$ define/nolog decc$user_include cdrroot:[libscg]
$ cc/prefix=all 'ccopt' MKISOFS.C
$ cc/prefix=all 'ccopt' getopt.c
$ cc/prefix=all 'ccopt' getopt1.c
$!$ cc/prefix=all 'ccopt' APPLE.C
$!$ cc/prefix=all 'ccopt' APPLE_DRIVER.C
$ cc/prefix=all 'ccopt' BOOT.C
$ if f$search("DVD_FILE.C") .nes. "" then $ cc/prefix=all 'ccopt' DVD_FILE.C
$ if f$search("DVD_READER.C") .nes. "" then $ cc/prefix=all 'ccopt' DVD_READER.C
$ cc/prefix=all 'ccopt' ELTORITO.C
$ cc/prefix=all 'ccopt' EXCLUDE.C
$ cc/prefix=all 'ccopt' FILES.C
$ cc/prefix=all 'ccopt' FNMATCH.C
$ cc/prefix=all 'ccopt' HASH.C
$ cc/prefix=all 'ccopt' JOLIET.C
$ cc/prefix=all 'ccopt' MATCH.C
$ cc/prefix=all 'ccopt' MULTI.C
$ cc/prefix=all 'ccopt' NAME.C
$ cc/prefix=all 'ccopt' ROCK.C
$ cc/prefix=all 'ccopt' SCSI.C
$ cc/prefix=all 'ccopt' TREE.C
$ cc/prefix=all 'ccopt' UDF.C
$ cc/prefix=all 'ccopt' VOLUME.C
$!$ cc/prefix=all 'ccopt' VMS.C
$ cc/prefix=all 'ccopt' WRITE.C
$ library/create/insert/object mkisofs.olb *.obj
$ delete *.obj;*
$
$ set default cdrroot:[vmstmp]
$
$ define/nolog decc$system_include  cdrroot:[cdrecord],cdrroot:[include]
$ define/nolog decc$user_include cdrroot:[cdrecord],cdrroot:[libscg]
$ cc/prefix=all 'ccopt' CDRECORD.C
$ cc/prefix=all 'ccopt' CDTEXT.C
$ if f$search("CRC16.C") .nes. "" then $ cc/prefix=all 'ccopt' CRC16.C
$ cc/prefix=all 'ccopt' SUBCHAN.C
$ if f$search("GETNUM.C") .nes. "" then $ cc/prefix=all 'ccopt' GETNUM.C
$ cc/prefix=all 'ccopt' MOVESECT.C
$ cc/prefix=all 'ccopt' CDR_DRV.C
$ cc/prefix=all 'ccopt' DRV_JVC.C
$ cc/prefix=all 'ccopt' DRV_MMC.C
$ cc/prefix=all 'ccopt' DRV_PHILIPS.C
$ cc/prefix=all 'ccopt' DRV_SONY.C
$ cc/prefix=all 'ccopt' DRV_SIMUL.C
$ cc/prefix=all 'ccopt' FIFO.C
$ cc/prefix=all 'ccopt' ISOSIZE.C
$ cc/prefix=all 'ccopt' MODES.C
$ cc/prefix=all 'ccopt' SCSIERRS.C
$ cc/prefix=all 'ccopt' SCSITRANSP.C
$ cc/prefix=all 'ccopt' SCSIOPEN.C
$ cc/prefix=all 'ccopt' SCSIHACK.C
$ cc/prefix=all 'ccopt' RDUMMY.C
$ cc/prefix=all 'ccopt' SCGSETTARGET.C
$ cc/prefix=all 'ccopt' SCGTIMES.C
$ cc/prefix=all 'ccopt' SCSI_CDR.C
$ cc/prefix=all 'ccopt' SCSI_SCAN.C
$ cc/prefix=all 'ccopt' WM_PACKET.C
$ cc/prefix=all 'ccopt' WM_SESSION.C
$ cc/prefix=all 'ccopt' WM_TRACK.C
$ cc/prefix=all 'ccopt' AUDIOSIZE.C
$ cc/prefix=all 'ccopt' DRV_SIMUL.C
$ cc/prefix=all 'ccopt' DISKID.C
$ cc/prefix=all 'ccopt' CD_MISC.C
$ cc/prefix=all 'ccopt' MISC.C
$ cc/prefix=all 'ccopt' DEFAULTS.C
$ cc/prefix=all 'ccopt' DEFAULT.C
$ library/create/insert/object cdrecord.olb *.obj
$
$ if f$search("mkisofs.olb") .eqs. "" then library/create/object mkisofs.olb
$
$ library/insert/object mkisofs.olb CD_MISC.obj
$ library/insert/object mkisofs.olb MODES.obj
$ library/insert/object mkisofs.olb SCSI_CDR.obj
$ delete *.obj;*
$!
$! Start test tool build.
$!
$ if f$search("INC.DIR") .eqs. ""
$ then 
$   create/dir cdrroot:[vmstmp.inc]
$ else
$   delete cdrroot:[vmstmp.inc]*.*;*
$ endif
$ copy cdrroot:[inc]*.* cdrroot:[vmstmp.inc]
$ set default cdrroot:[vmstmp.inc]
$ cc/prefix=all 'ccopt' ALIGN_TEST.C
$ link ALIGN_TEST
$ delete ALIGN_TEST.obj;*
$ define/user sys$output ALIGN.H
$ run ALIGN_TEST
$ cc/prefix=all 'ccopt' AVOFFSET.C
$ link AVOFFSET
$ delete AVOFFSET.obj;*
$ pipe run AVOFFSET > AVOFFSET.H
$ set default cdrroot:[vmstmp]
$!
$!$ if f$search("cdrroot:[000000]VIDEO.DIR") .eqs. ""
$!$ then
$!$   if f$search("cdrroot:[vmstmp]VIDEO.DIR") .eqs. ""
$!$   then 
$!$     create/dir cdrroot:[vmstmp.video
$!$   else
$!$     delete cdrroot:[vmstmp.video*.*;*
$!$   endif
$!$ copy cdrroot:[video]*.* cdrroot:[vmstmp.video]
$!$ cc/prefix=all COMPAT.C
$!$ cc/prefix=all CONFGEN.C
$!$ cc/prefix=all IFOGEN.C
$!$ endif
$!
$!
$! Start library build.
$!
$ if f$search("cdrroot:[vmstmp]LIB.DIR") .eqs. ""
$ then 
$   create/dir cdrroot:[vmstmp.lib]
$ else
$   delete cdrroot:[vmstmp.lib]*.*;*
$ endif
$ copy cdrroot:[libschily]*.* cdrroot:[vmstmp.lib]
$ set default cdrroot:[vmstmp.lib]
$ define/nolog decc$system_include cdrroot:[vmstmp.lib],cdrroot:[cdrecord],cdrroot:[include],cdrroot:[vmstmp.inc]
$ define/nolog decc$user_include cdrroot:[libscg]
$ cc/prefix=all 'ccopt' ASTOI.C
$ cc/prefix=all 'ccopt' ASTOLL.C
$ cc/prefix=all 'ccopt' COMERR.C
$ cc/prefix=all 'ccopt' ERROR.C
$ cc/prefix=all 'ccopt' FCONV.C
$!$ cc/prefix=all 'ccopt' FILLBYTES.C
$ cc/prefix=all 'ccopt' FORMAT.C
$ cc/prefix=all 'ccopt' GETARGS.C
$ cc/prefix=all 'ccopt' GETAV0.C
$ cc/prefix=all 'ccopt' GETERRNO.C
$ cc/prefix=all 'ccopt' GETFP.C
$!$ cc/prefix=all 'ccopt' MOVEBYTES.C
$!
$! Do not include printf.c for OpenVMS, as it will cause problems with this and with
$! various otherwise sane and careful linkers.  (As implemented within printf.c, the
$! replacement of standard C function calls with local code will cause reports of
$! duplicate-symbol errors.  I'm surprised at the number of compilers that apparently
$! do not strenuously complain about this misuse of the language.  If you need the
$! printf.c calls in your code -- OpenVMS does not -- please utilize different symbol
$! names, and pre-processor #defines to selet the alternate function.  Replacing the
$! standard library calls is exceedingly distant from good, portable coding practices.)
$!
$!$ cc/prefix=all 'ccopt' PRINTF.C
$ cc/prefix=all 'ccopt' RAISECOND.C
$ cc/prefix=all 'ccopt' SAVEARGS.C
$ cc/prefix=all 'ccopt' jsprintf.C
$ cc/prefix=all 'ccopt' jssnprintf.C
$ cc/prefix=all 'ccopt' STREQL.C
$ cc/prefix=all 'ccopt' SWABBYTES.C
$ cc/prefix=all 'ccopt' SERRMSG.C
$ library/create cdrroot:[vmstmp]lib.olb
$ library/insert cdrroot:[vmstmp]lib.olb *.obj
$ delete *.obj;*
$ set default cdrroot:[vmstmp]
$!
$! Start libschily build.
$!
$ if f$search("cdrroot:[vmstmp]STDIO.DIR") .eqs. ""
$ then 
$   create/dir cdrroot:[vmstmp.stdio]
$ else
$   delete cdrroot:[vmstmp.stdio]*.*;*
$ endif
$ copy cdrroot:[libschily.stdio]*.c cdrroot:[vmstmp.stdio]
$ set default cdrroot:[vmstmp.stdio]
$ define/nolog decc$system_include cdrroot:[cdrecord],cdrroot:[include]
$ define/nolog decc$user_include cdrroot:[libscg],cdrroot:[libschily.stdio]
$ CC/prefix=all 'ccopt' CVMOD.C
$ CC/prefix=all 'ccopt' DAT.C
$ CC/prefix=all 'ccopt' FCONS.C
$ CC/prefix=all 'ccopt' FGETLINE.C
$ CC/prefix=all 'ccopt' FILEOPEN.C
$ CC/prefix=all 'ccopt' FILEREAD.C
$ CC/prefix=all 'ccopt' FILESIZE.C
$ CC/prefix=all 'ccopt' FILEWRITE.C
$ CC/prefix=all 'ccopt' FLAG.C
$ CC/prefix=all 'ccopt' FLUSH.C
$ CC/prefix=all 'ccopt' NIREAD.C
$ library/create cdrroot:[vmstmp]stdio.olb
$ library/insert cdrroot:[vmstmp]stdio.olb *.obj
$ delete *.obj;*
$!
$! Start libunls build.
$!
$ if f$search("cdrroot:[vmstmp]LIBUNLS.DIR") .eqs. ""
$ then 
$   create/dir cdrroot:[vmstmp.LIBUNLS]
$ else
$   delete cdrroot:[vmstmp.LIBUNLS]*.*;*
$ endif
$ copy cdrroot:[libunls]*.c cdrroot:[vmstmp.LIBUNLS]
$ set default cdrroot:[vmstmp.LIBUNLS]
$ define/nolog decc$system_include cdrroot:[include]
$ define/nolog decc$user_include cdrroot:[libunls]
$ cc/prefix=all 'ccopt' nls_base.c
$ cc/prefix=all 'ccopt' nls_config.c
$ cc/prefix=all 'ccopt' nls_cp10000.c
$ cc/prefix=all 'ccopt' nls_cp10006.c
$ cc/prefix=all 'ccopt' nls_cp10007.c
$ cc/prefix=all 'ccopt' nls_cp10029.c
$ cc/prefix=all 'ccopt' nls_cp10079.c
$ cc/prefix=all 'ccopt' nls_cp10081.c
$ cc/prefix=all 'ccopt' nls_cp437.c
$ cc/prefix=all 'ccopt' nls_cp737.c
$ cc/prefix=all 'ccopt' nls_cp775.c
$ cc/prefix=all 'ccopt' nls_cp850.c
$ cc/prefix=all 'ccopt' nls_cp852.c
$ cc/prefix=all 'ccopt' nls_cp855.c
$ cc/prefix=all 'ccopt' nls_cp857.c
$ cc/prefix=all 'ccopt' nls_cp860.c
$ cc/prefix=all 'ccopt' nls_cp861.c
$ cc/prefix=all 'ccopt' nls_cp862.c
$ cc/prefix=all 'ccopt' nls_cp863.c
$ cc/prefix=all 'ccopt' nls_cp864.c
$ cc/prefix=all 'ccopt' nls_cp865.c
$ cc/prefix=all 'ccopt' nls_cp866.c
$ cc/prefix=all 'ccopt' nls_cp869.c
$ cc/prefix=all 'ccopt' nls_cp874.c
$ cc/prefix=all 'ccopt' nls_file.c
$ cc/prefix=all 'ccopt' nls_iso8859-1.c
$ cc/prefix=all 'ccopt' nls_iso8859-14.c
$ cc/prefix=all 'ccopt' nls_iso8859-15.c
$ cc/prefix=all 'ccopt' nls_iso8859-2.c
$ cc/prefix=all 'ccopt' nls_iso8859-3.c
$ cc/prefix=all 'ccopt' nls_iso8859-4.c
$ cc/prefix=all 'ccopt' nls_iso8859-5.c
$ cc/prefix=all 'ccopt' nls_iso8859-6.c
$ cc/prefix=all 'ccopt' nls_iso8859-7.c
$ cc/prefix=all 'ccopt' nls_iso8859-8.c
$ cc/prefix=all 'ccopt' nls_iso8859-9.c
$ cc/prefix=all 'ccopt' nls_koi8-r.c
$ library/create cdrroot:[vmstmp]libunls.olb
$ library/insert cdrroot:[vmstmp]libunls.olb *.obj
$ delete *.obj;*
$!
$foo:
$
$ set default cdrroot:[vmstmp]
$ link 'linkopt' CDRECORD.olb/include=cdrecord,cdrecord.olb/lib,lib.olb/lib,stdio.olb/lib
$ link 'linkopt' mkisofs.olb/include=mkisofs,mkisofs.olb/lib,cdrecord.olb/lib,lib.olb/lib,stdio.olb/lib,libunls.olb/lib
$ directory *.exe
$main_exit:
$ if f$trnlnm("decc$system_include","PROCESS") .nes. "" then deassign/process decc$system_include
$ if f$trnlnm("decc$user_include","PROCESS") .nes. "" then deassign/process decc$user_include
$ set default 'curdef'
$ exit
